// =====================================================
//
//  lazmla
//
// A lot of code and many ideas stolen from:
//   miniLA_win
//
//   (c) miniLA Team
//
// =====================================================
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This software is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this package; see the file COPYING.  If not, write to
// the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.


unit Uchans;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, CheckLst, Grids, ExtCtrls;

type

  { TFchannels }

  TFchannels = class(TForm)
    Bevel1: TBevel;
    Bevel2: TBevel;
    ButDone: TButton;
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    selchan: TCheckListBox;
    namchan: TStringGrid;
    procedure ButDoneClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure namchanEditingDone(Sender: TObject);
    procedure selchanClickCheck(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 
  Tchandat = record
    channr:integer;
    grpnr:integer;
    channame:array[0..31]of string;
    grpname:array[0..31]of string;
  end;

var
  Fchannels: TFchannels;
  channels_dat:Tchandat;

implementation

{ TFchannels }

uses uglobdat,ugraph;

procedure TFchannels.ButDoneClick(Sender: TObject);
begin
  Button1Click(self);
  Fchannels.Close;
end;

procedure TFchannels.Button1Click(Sender: TObject);
var i:integer; s:string;
begin
  for i:=1 to 32 do begin
     ChanUsed[i].used:=false;
     ChanUsed[i].grouped:=false; end;
  For i:=1 to selchan.Count do begin
     if selchan.Checked[i-1] then begin
        Chanused[i].used:=true;
        ChanUsed[i].name:=namchan.Cells[1,i];
        if (i mod 8)=1 then
          if pos('.',ChanUsed[i].name)<>0 then begin
            ChanUsed[i].grouped:=true;
            s:=ChanUsed[i].name;
            delete(s,pos('.',s),(length(s)-pos('.',s)+1));
            ChanUsed[i].name:=s;
          end;
     end;
  end;
end;

procedure TFchannels.FormActivate(Sender: TObject);
var i,j:integer; grouped:boolean; c:char;
begin //setup StringGrid and CheckListBox
      for i:=1 to 32 do begin
        if (i mod 8)=1 then
          if ChanUsed[i].grouped then begin
            grouped:=true; c:='0'; j:=i end
            else grouped:=false;
        if grouped then begin
          namchan.Cells[1,i]:=ChanUsed[j].name+'.'+c;
          c:=succ(c);
        end
        else namchan.Cells[1,i]:=ChanUsed[i].name;
        if Chanused[i].used then selchan.Checked[i-1]:=true
        else selchan.Checked[i-1]:=false;
      end;
end;


procedure TFchannels.FormCreate(Sender: TObject);
var i:integer; s:string;
begin for i:=1 to 32 do begin
          str(i:2,s); s:=s + '.Channel';
          selchan.Items.Add(s);
          if i < 17 then
            selchan.Checked[i-1]:=true
          else selchan.Checked[i-1]:=false;
          str(i:2,s); s:=s + '.Ch';
          namchan.Cells[0,i]:=s; namchan.Cells[1,i]:='Channel';
       end;
       namchan.Cells[0,0]:='  nr'; namchan.Cells[1,0]:=' name';

       channels_changed:=true;
       Button1Click(self);
end;

procedure TFchannels.namchanEditingDone(Sender: TObject);
var i:integer; s:string;
begin
       for i:=1 to 32 do  begin
         s:=namchan.Cells[1,i];
         while length(s)>8 do
              delete(s,9,(length(s)-8));
         namchan.Cells[1,i]:=s;
        if (selchan.Items[i-1]<>namchan.Cells[1,i]) and
            (namchan.Cells[1,i]<>'Channel') then
           selchan.Items[i-1]:=namchan.Cells[1,i];
       end;
       channels_changed:=true;
end;


procedure TFchannels.selchanClickCheck(Sender: TObject);
begin
  channels_changed:=true;
end;

initialization
  {$I uchans.lrs}

end.

