// =====================================================
//
//  lazmla
//
// A lot of code and many ideas stolen from:
//   miniLA_win
//
//   (c) miniLA Team
//
// =====================================================
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This software is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this package; see the file COPYING.  If not, write to
// the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.


unit Ufile;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, uglobdat;

procedure save_set(fname:string);
procedure load_set(fname:string);
procedure save_dat(fname:string);
procedure load_dat(fname:string);

implementation

procedure save_set(fname:string);
var t:TextFile; i:integer;
begin  Assignfile(t,fname);
       rewrite(t);
       writeln(t,'//Settings written from lazmla, do not edit!');
       writeln(t,'//MiniLA-Register-Values:');
       writeln(t,mlaregs.CTRL); writeln(t,mlaregs.TrigEC);
       writeln(t,mlaregs.TrigLC); writeln(t,mlaregs.TimeB);
       writeln(t,mlaregs.PrePost); writeln(t,mlaregs.TrigVal1);
       writeln(t,mlaregs.TrigVal2); writeln(t,mlaregs.TrigEdg1);
       writeln(t,mlaregs.TrigEdg2); writeln(t,mlaregs.TrigMask1);
       writeln(t,mlaregs.TrigMask2); writeln(t,mlaregs.TrigCTRL);
       writeln(t,'//Channels-Settings:');
       for i:=1 to 32 do begin
         if ChanUsed[i].name<>'' then writeln(t,ChanUsed[i].name)
          else writeln(t,' ');
         if ChanUsed[i].used then writeln(t,'1')
            else writeln(t,'0');
         if ChanUsed[i].grouped then writeln(t,'1')
            else writeln(t,'0');
       end;

       close(t);

end;

procedure load_set(fname:string);
var t:TextFile; i:integer; c:char;
begin  Assignfile(t,fname);
       reset(t); readln(t); readln(t);
       readln(t,mlaregs.CTRL); readln(t,mlaregs.TrigEC);
       readln(t,mlaregs.TrigLC); readln(t,mlaregs.TimeB);
       readln(t,mlaregs.PrePost); readln(t,mlaregs.TrigVal1);
       readln(t,mlaregs.TrigVal2); readln(t,mlaregs.TrigEdg1);
       readln(t,mlaregs.TrigEdg2); readln(t,mlaregs.TrigMask1);
       readln(t,mlaregs.TrigMask2); readln(t,mlaregs.TrigCTRL);
       readln(t);
       for i:=1 to 32 do begin
         readln(t,ChanUsed[i].name);
         if ChanUsed[i].name=' ' then ChanUsed[i].name:='';
         readln(t,c);
         if c='1' then ChanUsed[i].used:=true
            else ChanUsed[i].used:=false;
         readln(t,c);
         if c='1' then ChanUsed[i].grouped:=true
            else ChanUsed[i].grouped:=false;;
       end;
       close(t);
end;

procedure save_dat(fname:string);
var i:longint; t:TextFile;
begin
    AssignFile(t,fname); rewrite(t);
    for i:=0 to maxdatal-1 do begin
       write(t,chandat1[i],' ',chandat2[i],' ');
       writeln(t,chandat3[i],' ',chandat4[i]);
    end;
    close(t);
end;

procedure load_dat(fname:string);
var i:longint; t:TextFile; c:char;
begin
    AssignFile(t,fname); reset(t);
    for i:=0 to maxdatal-1 do begin
       read(t,chandat1[i],c,chandat2[i],c);
       readln(t,chandat3[i],c,chandat4[i]);
    end;
    close(t);
end;

end.

