// =====================================================
//
//  lazmla
//
// A lot of code and many ideas stolen from:
//   miniLA_win
//
//   (c) miniLA Team
//
// =====================================================
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This software is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this package; see the file COPYING.  If not, write to
// the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.


unit uglobdat;

{$mode objfpc}{$H+}
//globally used data

interface

uses
  Classes, SysUtils;

const
  maxdatal=131072;
  ftd_latency = 12; // 2 ... 255 ms

Type Tchandat=Array[0..maxdatal-1] of byte;

     Tmlaregs= record
        CTRL,TrigEC,TrigLC,TimeB,PrePost:byte;
        TrigVal1,TrigVal2,TrigEdg1,TrigEdg2:byte;
        TrigMask1,TrigMask2,TrigCTRL:byte;
        Data,Version,Status:byte; //Input-Registers;
     end;

     Tchantype = record
        used:boolean;
        grouped:boolean;
        name:string;
     end;
     Tchanused = array[1..32] of Tchantype;

var
  channels_changed:boolean; // for graphics
  chandat1,chandat2,chandat3,chandat4:Tchandat; //data-arrays
  ChanUsed:Tchanused; // used channels for graphics
  CommError:boolean;
  mla_connected:boolean;
  mlaregs:Tmlaregs;
  old_status:string; // for StatusBar1
  datalength:longint; // as readin from minila


  // used to calibrate the timeline:
  grafstep:integer;  // value from pixel to pixel
  grafbase:real;     // step between divisions
  grafunit:integer;  // exponent of grafbase

  // used to draw rhe signals:  9.1 divisions/screen
  grafstart:integer;  //first displayed division
  grafvalperdiv:integer; //depends from showbase
  grafmaxdiv:integer; //max. visible divisions, dito
  trigpos, cur1pos,cur2pos:longint;
  placecursor:integer;


implementation

initialization

mla_connected:=false;
// preset all registers with valid values:
mlaregs.CTRL:=0; mlaregs.TrigEC:=1; mlaregs.TrigLC:=1;
mlaregs.TimeB:=0; mlaregs.PrePost:=0; mlaregs.TrigVal1:=0;
mlaregs.TrigVal2:=0; mlaregs.TrigEdg1:=0; mlaregs.TrigEdg2:=0;
mlaregs.TrigMask1:=0; mlaregs.TrigMask2:=0;
mlaregs.TrigCTRL:=0;
// defaults for graphics change to triggerposition!
grafstart:=0;
grafstep:=1;
grafvalperdiv:=10;
grafmaxdiv:=13107;
trigpos:=8192;
cur1pos:=0;
cur2pos:=0;
placecursor:=0;

end.

