// =====================================================
//
//  lazmla
//
// A lot of code and many ideas stolen from:
//   miniLA_win
//
//   (c) miniLA Team
//
// =====================================================
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This software is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this package; see the file COPYING.  If not, write to
// the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.


unit Umain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ActnList, ComCtrls, Menus, Buttons, ExtCtrls, StdCtrls, uchans,
  utrig, mlausb, ufile;

type

  { TFmain }

  TFmain = class(TForm)
    Mconnect: TMenuItem;
    mgocur1: TMenuItem;
    mgocur2: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    mgotrig: TMenuItem;
    mgoend: TMenuItem;
    Mgostart: TMenuItem;
    mlareset: TMenuItem;
    Mminila: TMenuItem;
    ScrollBar1: TScrollBar;
    showbase: TComboBox;
    SpeedButton1: TSpeedButton;
    TBedge: TToolButton;
    Timer1: TTimer;
    ToggleBox1: TToggleBox;
    ToggleBox2: TToggleBox;
    ToolButton2: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    wave1: TImage;
    wave2: TImage;
    graf_but: TToolButton;
    ToolButton4: TToolButton;
    Trigger: TMenuItem;
    Timebase: TComboBox;
    ImageList1: TImageList;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    Channels: TMenuItem;
    File_Exit: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    StatusBar1: TStatusBar;
    ToolBar1: TToolBar;
    TBload: TToolButton;
    ToolButton10: TToolButton;
    TBsave: TToolButton;
    ToolButton3: TToolButton;
    ToolButton5: TToolButton;
    TimeBaseDonw: TToolButton;
    TimeBaseUp: TToolButton;
    StartStop: TToolButton;
    procedure ChannelsClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure File_ExitClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure graf_butClick(Sender: TObject);
    procedure MconnectClick(Sender: TObject);
    procedure MenuItem5Click(Sender: TObject);
    procedure MenuItem6Click(Sender: TObject);
    procedure MenuItem7Click(Sender: TObject);
    procedure MenuItem9Click(Sender: TObject);
    procedure mgocur1Click(Sender: TObject);
    procedure mgocur2Click(Sender: TObject);
    procedure mgoendClick(Sender: TObject);
    procedure MgostartClick(Sender: TObject);
    procedure mgotrigClick(Sender: TObject);
    procedure mlaresetClick(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure showbaseCloseUp(Sender: TObject);
    procedure TBloadClick(Sender: TObject);
    procedure TBsaveClick(Sender: TObject);
    procedure TimebaseCloseUp(Sender: TObject);
    procedure TimeBaseDonwClick(Sender: TObject);
    procedure TimeBaseUpClick(Sender: TObject);
    procedure StartStopClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ToggleBox1Click(Sender: TObject);
    procedure ToggleBox2Click(Sender: TObject);
    procedure TriggerClick(Sender: TObject);
    procedure wave2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Fmain: TFmain;

implementation

{ TFmain }

uses uglobdat, ugraph;

procedure calctimes;
var r:real; s:string; exp:integer;
begin
   r:=grafbase*(trigpos/10); exp:=grafunit;
   while r>=1000 do begin
      r:=r/1000; exp:=exp+3; end;
   if r>=100 then
      str(r:5:2,s)
   else if r>=10 then
           str(r:5:3,s)
        else str(r:5:4,s);
   s:=s+' ';
   case exp of
        -9:s:=s+'n';
        -6:s:=s+'u';
        -3:s:=s+'m';
         3:s:=s+'k';
         else
   end;
   if Fmain.Timebase.ItemIndex=18 then
      s:=s+'c'
   else s:=s+'s';
      Fmain.Statusbar1.Panels[1].Text:='Tt = '+s;
   if cur1pos<>0 then begin
      r:=grafbase*((cur1pos-trigpos)/10); exp:=grafunit;
      while abs(r)>=1000 do begin
         r:=r/1000; exp:=exp+3; end;
      if r>=100 then
              str(r:5:2,s)
              else if r>=10 then
                 str(r:5:3,s)
                 else str(r:5:4,s);
           s:=s+' ';
           case exp of
               -9:s:=s+'n';
               -6:s:=s+'u';
               -3:s:=s+'m';
                3:s:=s+'k';
                else
           end;
      if Fmain.Timebase.ItemIndex=18 then
              s:=s+'c'
      else s:=s+'s';
      Fmain.Statusbar1.Panels[2].Text:='Tc1-Tt = '+s;
   end;
   if cur2pos<>0 then begin
      r:=((cur2pos-trigpos)*grafbase)/10; exp:=grafunit;
      while abs(r)>=1000 do begin
         r:=r/1000; exp:=exp+3; end;
      if r>=100 then
              str(r:5:2,s)
              else if r>=10 then
                 str(r:5:3,s)
                 else str(r:5:4,s);
           s:=s+' ';
           case exp of
               -9:s:=s+'n';
               -6:s:=s+'u';
               -3:s:=s+'m';
                3:s:=s+'k';
                else
           end;
      if Fmain.Timebase.ItemIndex=18 then
              s:=s+'c'
      else s:=s+'s';
      Fmain.Statusbar1.Panels[3].Text:='Tc2-Tt = '+s;
   end;
   if (cur1pos<>0) and (cur2pos<>0) then begin
      r:=((cur2pos-cur1pos)*grafbase)/10; exp:=grafunit;
      while abs(r)>=1000 do begin
         r:=r/1000; exp:=exp+3; end;
      if r>=100 then
              str(r:5:2,s)
              else if r>=10 then
                 str(r:5:3,s)
                 else str(r:5:4,s);
           s:=s+' ';
           case exp of
               -9:s:=s+'n';
               -6:s:=s+'u';
               -3:s:=s+'m';
                3:s:=s+'k';
                else
           end;
      if Fmain.Timebase.ItemIndex=18 then
              s:=s+'c'
      else s:=s+'s';
      Fmain.Statusbar1.Panels[4].Text:='Tc2-Tc1 = '+s;
   end;

end;

procedure TFmain.File_ExitClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TFmain.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  if mla_connected then mla_close;
end;

procedure TFmain.FormCreate(Sender: TObject);
begin
  ToggleBox1.Color:=clGreen;
  ToggleBox2.Color:=clYellow;
end;

procedure TFmain.FormResize(Sender: TObject);
begin
  exit;
end;

procedure TFmain.FormActivate(Sender: TObject);
begin
  showbaseCloseUp(self);
  build_graph;
  channels_changed:=false;
  calctimes;
end;

procedure TFmain.ChannelsClick(Sender: TObject);
begin
  Fchannels.ShowModal;
end;

procedure TFmain.graf_butClick(Sender: TObject);
begin
  build_graph;
end;

procedure TFmain.MconnectClick(Sender: TObject);
var erg:boolean;  i:integer; s:string;
begin
  if Mconnect.Caption='Connect' then begin
    if mla_init then begin
      Mconnect.Caption:='Disconnect'; mla_connected:=true;
      mla_ReadStatus(true);
      i:=mlaregs.Version div 16; str(i:1,s);
      StatusBar1.Panels[0].Text:='FW '+s;
      i:=mlaregs.Version mod 16; str(i:1,s);
      StatusBar1.Panels[0].Text:= StatusBar1.Panels[0].Text+'.'+s;
      old_status:=StatusBar1.Panels[0].Text;
      mla_SetRegs; //preset all registers
      mla_connected:=true;
  end; end
  else begin
    erg:=mla_close; mla_connected:= false;
    Mconnect.Caption:='Connect';
    StatusBar1.Panels[0].Text:='';end;
end;



procedure TFmain.MenuItem5Click(Sender: TObject);
begin
  OpenDialog1.Title:='Load Data ';
  if OpenDialog1.Execute then load_dat(OpenDialog1.FileName);
  build_graph;
end;

procedure TFmain.MenuItem6Click(Sender: TObject);
begin
  TBloadClick(self);
end;

procedure TFmain.MenuItem7Click(Sender: TObject);
begin
  TBsaveClick(self);
end;

procedure TFmain.MenuItem9Click(Sender: TObject);
begin
  SaveDialog1.Title:='Save Data as ';
  if SaveDialog1.Execute then save_dat(SaveDialog1.FileName);
end;

procedure TFmain.mgocur1Click(Sender: TObject);
begin
  if cur1pos > 3 then
    grafstart:=(cur1pos div grafvalperdiv)-3
  else grafstart:=0;
  ScrollBar1.Position:=grafstart;
end;

procedure TFmain.mgocur2Click(Sender: TObject);
begin
  if cur2pos > 3 then
    grafstart:=(cur2pos div grafvalperdiv)-3
  else grafstart:=0;
  ScrollBar1.Position:=grafstart;
end;

procedure TFmain.mgoendClick(Sender: TObject);
begin
  if (grafmaxdiv-7)>0 then begin
     grafstart:=grafmaxdiv-7;
     //build_graph; end;
     ScrollBar1.Position:=grafstart; end
end;

procedure TFmain.MgostartClick(Sender: TObject);
begin
  grafstart:=0; Scrollbar1.Position:=0;
  //build_graph;
end;

procedure TFmain.mgotrigClick(Sender: TObject);
var i:integer; l:longint; r:real;
begin
  if mlaregs.PrePost>=16 then begin
     grafstart:=0; ScrollBar1.Position:=0; end
  else begin //pretrigger enabled:
       i:=mlaregs.PrePost mod 16;
       trigpos:=8192*(i+1);
       r:=grafmaxdiv/16; r:=r*(i+1);
       if r>3 then begin
         grafstart:=trunc(r-3);
         ScrollBar1.Position:=grafstart; end
       else begin
         grafstart:=0;
         ScrollBar1.Position:=0; end;
  end;
  //build_graph;
end;

procedure TFmain.mlaresetClick(Sender: TObject);
begin
  if mla_connected then begin
    mla_Reset;
    StatusBar1.Panels[0].Text:=old_status; end;
end;

procedure TFmain.ScrollBar1Change(Sender: TObject);
begin
      grafstart:=ScrollBar1.Position;
      build_graph;
end;

procedure TFmain.showbaseCloseUp(Sender: TObject);
var i,j:integer; r:real; s,st:string;  l:longint;
begin
  // setup calibrationvalues for the graphics
  i:=showbase.ItemIndex;
  s:=showbase.Items[i]; st:=s;
  while pos(' ',st)=1 do
        delete(st,1,1);
  i:=pos(' ',st); delete(st,i,(length(st)-i+1));
  val(st,i,j);
  //if j<>0 then showmessage('Invalid number '+st);
  grafbase:=i;
  if pos('n',s)<>0 then grafunit:=-9
  else if pos('u',s)<>0 then grafunit:=-6
       else if pos('m',s)<>0 then grafunit:=-3
            else if pos('k',s)<>0 then grafunit:=3
                 else grafunit:=0;
  l:=(grafstart+3)*grafvalperdiv; // remember the centerposition
  case showbase.ItemIndex of
      0: begin grafvalperdiv:=10; grafmaxdiv:=13107; end;
      1: begin grafvalperdiv:=20; grafmaxdiv:=6553; end;
      2: begin grafvalperdiv:=50; grafmaxdiv:=2621; end;
      3: begin grafvalperdiv:=100; grafmaxdiv:=1310; end;
      4: begin grafvalperdiv:=200; grafmaxdiv:=655; end;
      5: begin grafvalperdiv:=500; grafmaxdiv:=262; end;
      6: begin grafvalperdiv:=1000; grafmaxdiv:=131; end;
      7: begin grafvalperdiv:=2000; grafmaxdiv:=65; end;
      8: begin grafvalperdiv:=5000; grafmaxdiv:=26; end;
      9: begin grafvalperdiv:=10000; grafmaxdiv:=13; end;
  end;
  scrollbar1.Max:=grafmaxdiv;
  // set same screenposition as before change
  grafstart:=(l div grafvalperdiv)-3;
  scrollBar1.Position:=grafstart;
  //build_graph;
end;

procedure TFmain.TBloadClick(Sender: TObject);
var b:byte;
begin
  OpenDialog1.Title:='Load Settings ';
  If OpenDialog1.Execute then load_set(OpenDialog1.FileName);
  b:=mlaregs.TimeB;
  if (b div 32)=1 then begin
     tbedge.Down:=true; b:=b mod 32; end;
  if b=30 then TimeBase.ItemIndex:=19
  else TimeBase.ItemIndex:=mlaregs.TimeB;
  TimeBaseCloseup(self);
  channels_changed:=true; build_graph; channels_changed:=false;

end;

procedure TFmain.TBsaveClick(Sender: TObject);
begin
  SaveDialog1.Title:='Save Settings as ';
  SaveDialog1.DefaultExt:='txt';
  SaveDialog1.Filter:='*.txt';
  If SaveDialog1.Execute then save_set(SaveDialog1.FileName);
end;


procedure TFmain.TimebaseCloseUp(Sender: TObject);

var mant,decexp,i,j:integer; s,ts:string;
begin
  // set the selected TimeBaseValue

    If TimeBase.ItemIndex=19 then //external clock
       mlaregs.TimeB:=30
    else
       mlaregs.TimeB:=TimeBase.ItemIndex;
    if tbedge.Down then mlaregs.TimeB:=mlaregs.TimeB+32;
    if mla_connected then begin
      mla_setfreq; end;
  j:= Timebase.ItemIndex;
  // Build up showwbase-items, get first mantissa and exponent
  if j <> 19 then begin //internal Clock:
     decexp:=7-(j div 3);
     case (j mod 3) of
       0: mant:=1;
       1: mant:=2;
       2: mant:=5;
     end;
     // create 10 items in showbas:
     for i:=0 to 9 do begin
       str(mant,s); j:=decexp;
       while (j mod 3) <>0 do begin
         s:=s+'0'; j:=j+1; end;
       while length(s)<3 do s:=' '+s;
       s:=s+' ';
       case (j div 3) of
            1: s:=s+'ms';
            2: s:=s+'us';
            3: s:=s+'ns';
            else s:=s+'s';
            end;
       showbase.Items[i]:=s;
       case mant of
          1: mant:=2;
          2: mant:=5;
          5: begin mant:=1; decexp:=decexp-1; end; end;
     end;
  end
  else begin //external clock
     mant:=1; decexp:=1; //start with 10 clks
     for i:=0 to 9 do begin
       str(mant,s); j:=decexp;

       while (j mod 3) <>0 do begin
         s:=s+'0'; j:=j-1; end;
       while length(s)<3 do s:=' '+s;
       s:=s+' ';
       case (j div 3) of
            0: s:=s+'c';
            1: s:=s+'kc';
            end;
       showbase.Items[i]:=s;
       case mant of
          1: mant:=2;
          2: mant:=5;
          5: begin mant:=1; decexp:=decexp+1; end; end;
     end; end;
   showbase.ItemIndex:=1;
   showbase.ItemIndex:=0; showbase.Refresh;
   showbaseCloseUp(self);
end;

procedure TFmain.TimeBaseDonwClick(Sender: TObject);
begin
  If Timebase.ItemIndex < Timebase.Items.Count then begin
     Timebase.ItemIndex:=TimeBase.ItemIndex+1;
     TimeBaseCloseUp(self);
  end;

end;

procedure TFmain.TimeBaseUpClick(Sender: TObject);
begin
  If (Timebase.ItemIndex > 0) then begin
     Timebase.ItemIndex:=TimeBase.ItemIndex-1;
     TimeBaseCloseUp(self);
  end;

end;

procedure TFmain.StartStopClick(Sender: TObject);
var s:string;
begin
  If StartStop.ImageIndex=5 then begin
       StartStop.ImageIndex:=6;
       StartStop.Hint:='Stop';
       if mla_connected then begin
         mla_StartSample;
         Timer1.Enabled:=true;
//         old_status:=StatusBar1.Panels[0].Text;
         s:=old_status+' .. started';
         StatusBar1.Panels[0].Text:=s; end;
       end
  else begin
       StartStop.ImageIndex:=5;
       StartStop.Hint:='Start';
       if mla_connected then begin
         mla_StoppSample;
         Timer1.Enabled:=false;
         StatusBar1.Panels[0].Text:=old_status; end;
       end;
end;

procedure TFmain.Timer1Timer(Sender: TObject);
var i:integer; s:string; r:real;
begin
  mla_ReadStatus(false);
  i:=mlaregs.Status;
  if (i and 128) <> 0 then begin // sampling done
     StatusBar1.Panels[0].Text:=old_status+' .. done';
     Timer1.Enabled:=false;
     // Daten auslesen und button startstop wieder rcksetzen
     StatusBar1.Panels[0].Text:=old_status+' .. reading';
     StatusBar1.Refresh; Application.ProcessMessages;
     mla_ReadData;
     startstop.ImageIndex:=5;
     StatusBar1.Panels[0].Text:=old_status+' .. ready';
     // set grafstart: triggpoint should be visible
     if mlaregs.PrePost>=16 then grafstart:=0
     else begin //pretrigger enabled:
       i:=mlaregs.PrePost mod 16;
       trigpos:=8192*(i+1);
       r:=grafmaxdiv/16; r:=r*(i+1);
       if r>3 then grafstart:=trunc(r-3)
       else grafstart:=0;
     end;
  end
  else begin
     s:=' .. ???';
     if (i and 64)<>0 then begin
        if (i and 16)<>0 then s:=' .. triggered'
        else s:=' .. waiting'; end;
     s:=old_status+s;
     StatusBar1.Panels[0].Text:=s;
     StatusBar1.Refresh;
  end;

end;

procedure TFmain.ToggleBox1Click(Sender: TObject);
begin
  ToggleBox2.Checked:=false;
  placecursor:=1;
end;

procedure TFmain.ToggleBox2Click(Sender: TObject);
begin
  ToggleBox1.Checked:=false;
  placecursor:=2;
end;


procedure TFmain.TriggerClick(Sender: TObject);
begin
   Ftrig.ShowModal;
   if mla_connected then mla_SetRegs;
   mgotrigClick(self);
end;



procedure TFmain.wave2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var i:longint;
begin
  if (placecursor<>0) or (button=mbmiddle) then begin
    i:=grafstart*grafvalperdiv+(x div 100)*grafvalperdiv;
    if placecursor=1 then
       cur1pos:=i
    else cur2pos:=i;
    ToggleBox1.Checked:=false; ToggleBox2.Checked:=false;
    placecursor:=0; build_graph;
    calctimes;
  end
  else begin
   if x > 650 then begin
     if (Button=mbleft) and ((grafstart+9)<grafmaxdiv) then begin
        grafstart:=grafstart+1; end
     else if (button=mbright) and ((grafstart+12)<grafmaxdiv) then
       begin grafstart:=grafstart+4; end
   end
   else if x< 70 then begin
     if (button=mbleft) and (grafstart>0) then begin
        grafstart:=grafstart-1; end
     else if (button=mbright) and (grafstart>3) then begin
        grafstart:=grafstart-4; end;
   end;
   ScrollBar1.Position:=grafstart;
   end;
end;

initialization
  {$I umain.lrs}
  channels_changed:=true;


end.

